Bug 1609067 - pldd does not wait for SIGSTOP after PTRACE_ATTACH
Summary: pldd does not wait for SIGSTOP after PTRACE_ATTACH
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.5
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: rc
: ---
Assignee: Patsy Franklin
QA Contact: qe-baseos-tools
URL:
Whiteboard:
Depends On:
Blocks: 1594286 1643040
TreeView+ depends on / blocked
 
Reported: 2018-07-26 21:53 UTC by Andrew Mike
Modified: 2019-08-06 12:49 UTC (History)
12 users (show)

Fixed In Version: glibc-2.17-270.el7
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of:
Environment:
Last Closed: 2019-08-06 12:49:05 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2118 None None None 2019-08-06 12:49:33 UTC
Sourceware 15804 None None None 2019-06-19 12:52:41 UTC

Description Andrew Mike 2018-07-26 21:53:19 UTC
Description of problem: When pldd is running against an application, if the the SIGSTOP signal is not delivered to the tracee immediately after PTRACE_ATTACH, pldd will not wait for the tracee to stop before continuing.

Version-Release number of selected component (if applicable):
glibc-common 2.17-222

How reproducible:
Issue is randomly reproducible as a result of the race between the delivery of SIGSTOP and PTRACE_DETACH. Incidence of this issue increases if done in a virtual machine.

Steps to Reproduce:
1. Run "pldd $$" to trace the bash shell.

Actual results:
At random, bash will remain in T state after pldd's trace has completed until a SIGCONT is delivered.

Expected results:
After pldd is finished, bash is resumed.

Additional info:
The Sourceware bug also includes a patch.

Comment 2 Carlos O'Donell 2018-07-27 00:52:16 UTC
Andrew,

Thanks for the bug report and the pointers to the patch that solves the problem.

We will review this as part of our normal bug review process.

If you have an questions or if this issue starts to impact any customers, please raise the severity.

Comment 5 Sergey Kolosov 2019-06-11 19:50:33 UTC
Verified,
reproduced in glibc-2.17-260.el7 on x86_64 and s390x,
didn't reproduce in glibc-2.17-270.el7

Comment 7 errata-xmlrpc 2019-08-06 12:49:05 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:2118


Note You need to log in before you can comment on or make changes to this bug.